security:
    encoders:
        App\Entity\User:
            algorithm: auto

    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: username
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            anonymous: true
            guard:
                authenticators:
                    - App\Security\LoginFormAuthenticator
            logout:
                path: app_logout
                target: app_login
        # where to redirect after logout
        # target: app_any_route
      # activate different ways to authenticate
      # https://symfony.com/doc/current/security.html#firewalls-authentication

      # https://symfony.com/doc/current/security/impersonating_user.html
      # switch_user: true

  # Easy way to control access for large sections of your site
  # Note: Only the *first* access control that matches will be used
    access_control:
        # - { path: ^/admin, roles: ROLE_ADMIN }
        # - { path: ^/profile, roles: ROLE_USER }
        - { path: ^/login$, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        #  - { path: ^/register$, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/chefdepartement$, roles: ROLE_CHEF_DEPARTEMENT }
        - { path: ^/admin$, roles: ROLE_ADMIN }
        - { path: ^/doyen$, roles: ROLE_DOYEN }
        - { path: ^/secretairegeneral$, roles: ROLE_SECRETAIRE_GENERAL }
        - { path: ^/scolarite$, roles: ROLE_SCOLARITE }
        - { path: ^/agent$, roles: ROLE_AGENT }
        #- { path: ^/user/profile, roles: IS_AUTHENTICATED_FULLY }
